Index: /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/create_boundary.f90
===================================================================
--- /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/create_boundary.f90	(revision 5212)
+++ /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/create_boundary.f90	(revision 5213)
@@ -368,253 +532,370 @@
    ENDDO
 
+   ! clean
+   CALL var_clean(tl_level(:))
    DEALLOCATE(tl_level)
 
-   !7- compute boundary for variable to be used (see namelist)
-   IF( .NOT. ASSOCIATED(tl_multi%t_file) )THEN
+   ! clean bathy
+   CALL mpp_clean(tl_bathy1)
+
+   ALLOCATE( tl_segvar1(tl_multi%i_nvar,ip_maxseg,ip_ncard) )
+   ! compute boundary for variable to be used (see namelist)
+   IF( .NOT. ASSOCIATED(tl_multi%t_mpp) )THEN
       CALL logger_error("CREATE BOUNDARY: no file to work on. "//&
       &                 "check cn_varfile in namelist.")
    ELSE
+
       jvar=0
       ! for each file
-      DO ji=1,tl_multi%i_nfile
-         WRITE(cl_data,'(a,i2.2)') 'data_',jvar+1
-
-         IF( .NOT. ASSOCIATED(tl_multi%t_file(ji)%t_var) )THEN
+      DO ji=1,tl_multi%i_nmpp
+
+         WRITE(cl_data,'(a,i2.2)') 'data-',jvar+1
+
+         IF( .NOT. ASSOCIATED(tl_multi%t_mpp(ji)%t_proc(1)%t_var) )THEN
+
             CALL logger_error("CREATE BOUNDARY: no variable to work on for "//&
-            &                 "file "//TRIM(tl_multi%t_file(ji)%c_name)//&
+            &                 "mpp "//TRIM(tl_multi%t_mpp(ji)%c_name)//&
             &                 ". check cn_varfile in namelist.")
+
+         ELSEIF( TRIM(tl_multi%t_mpp(ji)%c_name) == TRIM(cl_data) )THEN
+         !- use input matrix to fill variable
+
+            WRITE(*,'(a)') "work on data"
+            ! for each variable initialise from matrix
+            DO jj=1,tl_multi%t_mpp(ji)%t_proc(1)%i_nvar
+
+               jvar=jvar+1
+               WRITE(*,'(2x,a,a)') "work on variable "//&
+               &  TRIM(tl_multi%t_mpp(ji)%t_proc(1)%t_var(jj)%c_name)
+
+               tl_var1=var_copy(tl_multi%t_mpp(ji)%t_proc(1)%t_var(jj))
+
+               SELECT CASE(TRIM(tl_var1%c_point))
+               CASE DEFAULT !'T'
+                  jpoint=jp_T
+               CASE('U')
+                  jpoint=jp_U
+               CASE('V')
+                  jpoint=jp_V
+               CASE('F')
+                  jpoint=jp_F
+               END SELECT
+
+               WRITE(*,'(4x,a,a)') 'work on '//TRIM(tl_var1%c_name)
+               DO jl=1,ip_ncard
+                  IF( tl_bdy(jl)%l_use )THEN
+
+                     DO jk=1,tl_bdy(jl)%i_nseg
+
+                        ! fill value with matrix data
+                        tl_segvar1(jvar,jk,jl)=create_boundary_matrix( &
+                        &                          tl_var1, &
+                        &                          tl_segdom1(jpoint,jk,jl), &
+                        &                          in_nlevel )
+
+                        ! use mask
+                        CALL create_boundary_use_mask( tl_segvar1(jvar,jk,jl), &
+                        &                         tl_seglvl1(jpoint,jk,jl))
+
+                        !del extra
+                        CALL dom_del_extra( tl_segvar1(jvar,jk,jl), &
+                        &                   tl_segdom1(jpoint,jk,jl) )
+
+                     ENDDO
+
+                  ENDIF
+               ENDDO
+               
+               ! clean
+               CALL var_clean(tl_var1)
+
+            ENDDO
+
+         !- end of use input matrix to fill variable
          ELSE
-            IF( .NOT. ASSOCIATED(tl_multi%t_file(ji)%t_var) )THEN
-
-               CALL logger_error("CREATE BOUNDARY: no variable to work on for "//&
-               &                 "file "//TRIM(tl_multi%t_file(ji)%c_name)//&
-               &                 ". check cn_varfile in namelist.")
-
-            ELSEIF( TRIM(tl_multi%t_file(ji)%c_name) == TRIM(cl_data) )THEN
-            !- use input matrix to fill variable
-
-               ! for each variable initialise from matrix
-               DO jj=1,tl_multi%t_file(ji)%i_nvar
-                  jvar=jvar+1
-                  tl_tmp=tl_multi%t_file(ji)%t_var(jj)
-                  DO jk=1,ip_ncard
-                     IF( tl_bdy(jk)%l_use )THEN
-                        DO jl=1,tl_bdy(jk)%i_nseg
-                           !7-1 fill value with matrix data
-                           ! pb voir comment gerer nb de dimension
-                           tl_segvar1(jvar,jk,jl)=create_bdy_matrix(tl_tmp, tl_segdom1(jk,jl), tl_coord1)
-
-                           !7-2 use mask
-                           CALL create_bdy_use_mask(tl_segvar1(jvar,jk,jl), tl_seglvl1(jk,jl,:))
-                        ENDDO
-                     ENDIF
-                  ENDDO
-               ENDDO
-
+         !- use file to fill variable
+
+            WRITE(*,'(a)') "work on file "//TRIM(tl_multi%t_mpp(ji)%c_name)
+            ! 
+            tl_mpp=mpp_init(file_init(TRIM(tl_multi%t_mpp(ji)%t_proc(1)%c_name)))
+            CALL grid_get_info(tl_mpp)
+
+            ! check vertical dimension
+            IF( tl_mpp%t_dim(jp_K)%l_use .AND. &
+            &   tl_mpp%t_dim(jp_K)%i_len /= in_nlevel  )THEN
+               CALL logger_error("CREATE BOUNDARY: dimension in file "//&
+               &  TRIM(tl_mpp%c_name)//" not agree with namelist in_nlevel ")
+            ENDIF
+
+            ! open mpp file
+            CALL iom_mpp_open(tl_mpp)
+
+            ! get or check depth value
+            CALL create_boundary_check_depth( tl_mpp, tl_depth )
+
+            ! get or check time value
+            CALL create_boundary_check_time( tl_mpp, tl_time )
+
+            ! close mpp file
+            CALL iom_mpp_close(tl_mpp)
+
+            IF( ANY( tl_mpp%t_dim(1:2)%i_len /= &
+            &        tl_coord0%t_dim(1:2)%i_len) )THEN
+            !- extract value from fine grid
+
+               IF( ANY( tl_mpp%t_dim(1:2)%i_len <= &
+               &        tl_coord1%t_dim(1:2)%i_len) )THEN
+                  CALL logger_fatal("CREATE BOUNDARY: dimension in file "//&
+                  &  TRIM(tl_mpp%c_name)//" smaller than those in fine"//&
+                  &  " grid coordinates.")
+               ENDIF
+
+               DO jl=1,ip_ncard
+                  IF( tl_bdy(jl)%l_use )THEN
+                     
+                     WRITE(*,'(2x,a,a)') 'work on '//TRIM(tl_bdy(jl)%c_card)//' boundary'
+                     DO jk=1,tl_bdy(jl)%i_nseg
+                        ! compute domain on fine grid
+                        
+                        ! for each variable of this file
+                        DO jj=1,tl_multi%t_mpp(ji)%t_proc(1)%i_nvar
+                           
+                           cl_name=tl_multi%t_mpp(ji)%t_proc(1)%t_var(jj)%c_name
+                           WRITE(*,'(4x,a,a)') "work on variable "//TRIM(cl_name)
+
+                           cl_point=tl_multi%t_mpp(ji)%t_proc(1)%t_var(jj)%c_point
+                           ! open mpp file on domain
+                           SELECT CASE(TRIM(cl_point))
+                              CASE DEFAULT !'T'
+                                 jpoint=jp_T
+                              CASE('U')
+                                 jpoint=jp_U
+                              CASE('V')
+                                 jpoint=jp_V
+                              CASE('F')
+                                 jpoint=jp_F
+                           END SELECT
+
+                           tl_dom1=dom_copy(tl_segdom1(jpoint,jk,jl))
+                           tl_lvl1=var_copy(tl_seglvl1(jpoint,jk,jl))
+
+                           ! open mpp files
+                           CALL iom_dom_open(tl_mpp, tl_dom1)
+
+                           !7-5 read variable over domain
+                           tl_segvar1(jvar+jj,jk,jl)=iom_dom_read_var( &
+                           &                     tl_mpp, TRIM(cl_name), tl_dom1)
+
+                           ! use mask
+                           CALL create_boundary_use_mask( &
+                           &                 tl_segvar1(jvar+jj,jk,jl), tl_lvl1)
+
+                           ! del extra point
+                           CALL dom_del_extra( tl_segvar1(jvar+jj,jk,jl), &
+                           &                   tl_dom1 )
+
+                           ! clean extra point information on fine grid domain
+                           CALL dom_clean_extra( tl_dom1 )
+
+                           ! add attribute to variable
+                           tl_att=att_init('src_file',TRIM(fct_basename(tl_mpp%c_name)))
+                           CALL var_move_att(tl_segvar1(jvar+jj,jk,jl), tl_att)
+
+                           tl_att=att_init('src_i_indices',(/tl_dom1%i_imin, tl_dom1%i_imax/))
+                           CALL var_move_att(tl_segvar1(jvar+jj,jk,jl), tl_att)
+
+                           tl_att=att_init('src_j_indices',(/tl_dom1%i_jmin, tl_dom1%i_jmax/))
+                           CALL var_move_att(tl_segvar1(jvar+jj,jk,jl), tl_att)
+
+                           ! clean structure
+                           CALL att_clean(tl_att)
+                           CALL dom_clean(tl_dom1)
+
+                           ! close mpp files
+                           CALL iom_dom_close(tl_mpp)
+
+                           ! clean
+                           CALL var_clean(tl_lvl1)
+
+                        ENDDO ! jj
+                     ENDDO ! jk
+
+                  ENDIF
+               ENDDO ! jl
+
+               ! clean
+               CALL mpp_clean(tl_mpp)
+
+               jvar=jvar+tl_multi%t_mpp(ji)%t_proc(1)%i_nvar
+
+            !- end of extract value from fine grid
             ELSE
-            !- use file to fill variable
-
-               ! open file
-               tl_file=file_init(TRIM(tl_multi%t_file(ji)%c_name))
-               CALL iom_open(tl_file)
-
-               ! get or check depth value
-               IF( tl_file%i_depthid /= 0 )THEN
-                  IF( ASSOCIATED(tl_depth%d_value) )THEN
-                     IF( ANY( tl_depth%d_value(:,:,:,:) /= &
-                     &        tl_tmp%d_value(:,:,:,:) ) )THEN
-                        CALL logger_fatal("CREATE BOUNDARY: depth value from "//&
-                        &  TRIM(tl_multi%t_file(ji)%c_name)//" not conform "//&
-                        &  " to those from former file(s).")
-                     ENDIF
-                  ELSE
-                     tl_depth=iom_read_var(tl_file,tl_file%i_depthid)
-                  ENDIF
-               ENDIF
-
-               ! get or check time value
-               IF( tl_file%i_timeid /= 0 )THEN
-                  IF( ASSOCIATED(tl_time%d_value) )THEN
-                     IF( ANY( tl_time%d_value(:,:,:,:) /= &
-                     &        tl_tmp%d_value(:,:,:,:) ) )THEN
-                        CALL logger_fatal("CREATE BOUNDARY: time value from "//&
-                        &  TRIM(tl_multi%t_file(ji)%c_name)//" not conform "//&
-                        &  " to those from former file(s).")
-                     ENDIF
-                  ELSE
-                     tl_time=iom_read_var(tl_file,tl_file%i_timeid)
-                  ENDIF
-               ENDIF
-
-               IF( ANY( tl_file%t_dim(1:2)%i_len /= &
-               &      tl_coord0%t_dim(1:2)%i_len) )THEN
-               !- extract value from fine grid
-                  DO jk=1,ip_ncard
-                     IF( tl_bdy(jk)%l_use )THEN
-
-                        DO jl=1,tl_bdy(jk)%i_nseg
-                           !7-1 compute domain on fine grid
+            !- interpolate value from coarse grid
+
+               DO jl=1,ip_ncard
+                  IF( tl_bdy(jl)%l_use )THEN
+
+                     WRITE(*,'(2x,a,a)') 'work on '//TRIM(tl_bdy(jl)%c_card)//' boundary'
+                     DO jk=1,tl_bdy(jl)%i_nseg
+                        
+                        ! for each variable of this file
+                        DO jj=1,tl_multi%t_mpp(ji)%t_proc(1)%i_nvar
                            
+                           WRITE(*,'(4x,a,a)') "work on variable "//&
+                           &  TRIM(tl_multi%t_mpp(ji)%t_proc(1)%t_var(jj)%c_name)
+
+                           tl_var0=var_copy(tl_multi%t_mpp(ji)%t_proc(1)%t_var(jj))
                            ! open mpp file on domain
-                           !7-2 init mpp structure
-                           tl_mpp=mpp_init(tl_file)
-
-                           !7-3 get processor to be used
-                           CALL mpp_get_use( tl_mpp, tl_segdom1(jk,jl) )
-                           !7-4 open mpp files
-                           CALL iom_mpp_open(tl_mpp)
-
-                           ! for each variable of this file
-                           DO jj=1,tl_multi%t_file(ji)%i_nvar
-                              
-                              cl_name=tl_multi%t_file(ji)%t_var(jj)%c_name
-                              !7-5 read variable over domain
-                              tl_segvar1(jvar+jj,jk,jl)=iom_mpp_read_var( tl_mpp, TRIM(cl_name), &
-                              &                                           td_dom=tl_segdom1(jk,jl) )
-
-                              !7-6 add attribute to variable
-                              tl_att=att_init('src_file',TRIM(fct_basename(tl_mpp%c_name)))
-                              CALL var_move_att(tl_segvar1(jvar+jj,jk,jl), tl_att)
-
-                              tl_att=att_init('src_i-indices',(/tl_segdom1(jk,jl)%i_imin, tl_segdom1(jk,jl)%i_imax/))
-                              CALL var_move_att(tl_segvar1(jvar+jj,jk,jl), tl_att)
-
-                              tl_att=att_init('src_j-indices',(/tl_segdom1(jk,jl)%i_jmin, tl_segdom1(jk,jl)%i_jmax/))
-                              CALL var_move_att(tl_segvar1(jvar+jj,jk,jl), tl_att)
-                              
-                              ! clean structure
-                              CALL att_clean(tl_att)
-
-                              !7-7 use mask
-                              CALL create_bdy_use_mask(tl_segvar1(jvar+jj,jk,jl), tl_seglvl1(jk,jl,:))
-                           ENDDO
-                           
-                           !7-8 close mpp files
-                           CALL iom_mpp_close(tl_mpp)
-
-                           CALL mpp_clean(tl_mpp)
-
-                        ENDDO
-                     ENDIF
-                  ENDDO
-                  jvar=jvar+tl_multi%t_file(ji)%i_nvar
-               ELSE
-               !- interpolate value from coarse grid
-
-                  DO jk=1,ip_ncard
-                     IF( tl_bdy(jk)%l_use )THEN
-
-                        DO jl=1,tl_bdy(jk)%i_nseg
-                           !7-1 get coarse grid indices of this segment
-                           il_ind(:,:,:)=grid_get_coarse_index(tl_coord0, &
-                           &                                   tl_seglon1(jk,jl), tl_seglat1(jk,jl), &
-                           &                                   id_rho=il_rho(:) )
-
-                           IF( ANY(il_ind(:,:,:)==0) )THEN
-                              CALL logger_error("CREATE BOUNDARY: error computing "//&
-                              &                 " coarse grid indices")
+                           SELECT CASE(TRIM(tl_var0%c_point))
+                              CASE DEFAULT !'T'
+                                 jpoint=jp_T
+                              CASE('U')
+                                 jpoint=jp_U
+                              CASE('V')
+                                 jpoint=jp_V
+                              CASE('F')
+                                 jpoint=jp_F
+                           END SELECT
+
+                           tl_dom1=dom_copy(tl_segdom1(jpoint,jk,jl))
+                           tl_lvl1=var_copy(tl_seglvl1(jpoint,jk,jl))
+
+                           CALL create_boundary_get_coord( tl_coord1, tl_dom1, &
+                           &                               tl_var0%c_point,    &
+                           &                               tl_lon1, tl_lat1 )
+
+                           ! get coarse grid indices of this segment
+                           il_ind(:,:)=grid_get_coarse_index(tl_coord0, &
+                           &                                 tl_lon1, tl_lat1, &
+                           &                                 id_rho=il_rho(:) )
+
+                           IF( ANY(il_ind(:,:)==0) )THEN
+                              CALL logger_error("CREATE BOUNDARY: error "//&
+                              &  "computing coarse grid indices")
                            ELSE
-                              il_imin0=il_ind(1,1,1)
-                              il_imax0=il_ind(1,2,1)
-
-                              il_jmin0=il_ind(2,1,1)
-                              il_jmax0=il_ind(2,2,1)
-
-                              il_offset(:,:)=il_ind(:,:,2)
+                              il_imin0=il_ind(1,1)
+                              il_imax0=il_ind(1,2)
+
+                              il_jmin0=il_ind(2,1)
+                              il_jmax0=il_ind(2,2)
                            ENDIF
 
-                           !7-2 compute coarse grid segment domain
+                           il_offset(:,:)= grid_get_fine_offset( &
+                           &                    tl_coord0, &
+                           &                    il_imin0, il_jmin0,&
+                           &                    il_imax0, il_jmax0,&
+                           &                    tl_lon1%d_value(:,:,1,1),&
+                           &                    tl_lat1%d_value(:,:,1,1),&
+                           &                    il_rho(:),&
+                           &                    TRIM(tl_var0%c_point) )
+
+                           ! compute coarse grid segment domain
                            tl_dom0=dom_init( tl_coord0,         &
                            &                 il_imin0, il_imax0,&
                            &                 il_jmin0, il_jmax0 )
 
-                           !7-3 add extra band (if possible) to compute interpolation
+                           ! add extra band (if possible) to compute interpolation
                            CALL dom_add_extra(tl_dom0)
 
-                           !7-4 read variables on domain (ugly way to do it, have to work on it)
-                           !7-4-1 init mpp structure
-                           tl_mpp=mpp_init(tl_file)
- 
-                           !7-4-2 get processor to be used
-                           CALL mpp_get_use( tl_mpp, tl_dom0 )
-
-                           !7-4-3 open mpp files
-                           CALL iom_mpp_open(tl_mpp)
-
-                           ! check file dimension
-                           IF( ANY(tl_mpp%t_dim(1:2)%i_len /= tl_coord0%t_dim(1:2)%i_len) )THEN
-                              CALL logger_error("CREATE BOUNDARY INTERP: dimension of file "//&
-                              &  TRIM(tl_mpp%c_name)//" not conform to those of "//&
-                              &  TRIM(tl_coord0%c_name))
-                           ELSE
-
-                              ! for each variable of this file
-                              DO jj=1,tl_multi%t_file(ji)%i_nvar
-
-                                 cl_name=tl_multi%t_file(ji)%t_var(jj)%c_name
-                                 !7-4-4 read variable value on domain
-                                 tl_segvar1(jvar+jj,jk,jl)=iom_mpp_read_var( tl_mpp, TRIM(cl_name), &
-                                 &                                           td_dom=tl_dom0 )
-
-                                 !7-4-5 work on variable
-                                 CALL create_boundary_interp(tl_segvar1(jvar+jj,jk,jl), &
-                                 &                           il_rho(:), &
-                                 &                           il_offset(:,:) )
-
-                                 !7-4-6 remove extraband added to domain
-                                 CALL dom_del_extra( tl_segvar1(jvar+jj,jk,jl), tl_dom0, il_rho(:) )
-
-                                 !7-4-7 keep only useful point (width) 
-                                 ! interpolation could create more point than necessary
-                                 CALL boundary_clean_interp(tl_segvar1(jvar+jj,jk,jl), tl_bdy(jk) )
-
-                                 !7-4-8 add attribute to variable
-                                 tl_att=att_init('src_file',TRIM(fct_basename(tl_mpp%c_name)))
-                                 CALL var_move_att(tl_segvar1(jvar+jj,jk,jl), tl_att)
-
-                                 tl_att=att_init('src_i-indices',(/tl_dom0%i_imin, tl_dom0%i_imax/))
-                                 CALL var_move_att(tl_segvar1(jvar+jj,jk,jl), tl_att)
-
-                                 tl_att=att_init('src_j-indices',(/tl_dom0%i_jmin, tl_dom0%i_jmax/))
-                                 CALL var_move_att(tl_segvar1(jvar+jj,jk,jl), tl_att)
-
-                                 ! clean structure
-                                 CALL att_clean(tl_att)
-
-                                 !7-4-9 use mask
-                                 CALL create_bdy_use_mask(tl_segvar1(jvar+jj,jk,jl), tl_seglvl1(jk,jl,:))
-                              ENDDO
+                           ! read variables on domain 
+                           ! open mpp files
+                           CALL iom_dom_open(tl_mpp, tl_dom0)
+
+                           cl_name=tl_var0%c_name
+                           ! read variable value on domain
+                           tl_segvar1(jvar+jj,jk,jl)= &
+                           &    iom_dom_read_var(tl_mpp, TRIM(cl_name), tl_dom0)
+
+                           ! work on variable
+                           CALL create_boundary_interp( &
+                           &                 tl_segvar1(jvar+jj,jk,jl),&
+                           &                 il_rho(:), il_offset(:,:) )
+
+                           ! remove extraband added to domain
+                           CALL dom_del_extra( tl_segvar1(jvar+jj,jk,jl), &
+                           &                   tl_dom0, il_rho(:) )
+
+                           ! use mask
+                           CALL create_boundary_use_mask( &
+                           &     tl_segvar1(jvar+jj,jk,jl), tl_lvl1)
+
+                           ! del extra point on fine grid
+                           CALL dom_del_extra( tl_segvar1(jvar+jj,jk,jl), &
+                           &                   tl_dom1 )
+                           ! clean extra point information on coarse grid domain
+                           CALL dom_clean_extra( tl_dom0 )
+
+                           ! add attribute to variable
+                           tl_att=att_init('src_file',&
+                           &  TRIM(fct_basename(tl_mpp%c_name)))
+                           CALL var_move_att(tl_segvar1(jvar+jj,jk,jl), &
+                           &                 tl_att)
+
+                           ! use clean extra avt creer attribut
+                           tl_att=att_init('src_i-indices',&
+                           &  (/tl_dom0%i_imin, tl_dom0%i_imax/))
+                           CALL var_move_att(tl_segvar1(jvar+jj,jk,jl), &
+                           &                 tl_att)
+
+                           tl_att=att_init('src_j-indices', &
+                           &  (/tl_dom0%i_jmin, tl_dom0%i_jmax/))
+                           CALL var_move_att(tl_segvar1(jvar+jj,jk,jl), &
+                           &                 tl_att)
+
+                           IF( ANY(il_rho(:)/=1) )THEN
+                              tl_att=att_init("refinment_factor", &
+                              &               (/il_rho(jp_I),il_rho(jp_J)/))
+                              CALL var_move_att(tl_segvar1(jvar+jj,jk,jl), &
+                              &                 tl_att)
                            ENDIF
 
+                           ! clean structure
+                           CALL att_clean(tl_att)
+
+                           ! clean
                            CALL dom_clean(tl_dom0)
-
-                           !7-5 close mpp files
-                           CALL iom_mpp_close(tl_mpp)
-
-                           !7-6 clean structure
-                           CALL mpp_clean(tl_mpp)
-                        ENDDO
-                     ENDIF
-                  ENDDO
-                  jvar=jvar+tl_multi%t_file(ji)%i_nvar
-
-               ENDIF
-               CALL file_clean(tl_file)
-
+                           CALL dom_clean(tl_dom1)
+
+                           ! close mpp files
+                           CALL iom_dom_close(tl_mpp)
+
+                           ! clean structure
+                           CALL var_clean(tl_lon1)
+                           CALL var_clean(tl_lat1)
+                           CALL var_clean(tl_lvl1)
+
+                        ENDDO ! jj
+
+                        ! clean
+                        CALL var_clean(tl_var0)
+
+                     ENDDO ! jk
+               
+                  ENDIF
+               ENDDO ! jl
+
+               jvar=jvar+tl_multi%t_mpp(ji)%t_proc(1)%i_nvar
+
+            !- end of interpolate value from coarse grid
             ENDIF
+
+            ! clean
+            CALL mpp_clean(tl_mpp)
+
+         !- end of use file to fill variable
          ENDIF
       ENDDO
    ENDIF
+
    IF( jvar /= tl_multi%i_nvar )THEN
       CALL logger_error("CREATE BOUNDARY: it seems some variable can not be read")
    ENDIF
 
-   !8- concatenate file
-   ALLOCATE( tl_lon1(ip_ncard) )
-   ALLOCATE( tl_lat1(ip_ncard) )
-   ALLOCATE( tl_var(tl_multi%i_nvar,ip_ncard) )
-
-   DO jk=1,ip_ncard
-      IF( tl_bdy(jk)%l_use )THEN
+   CALL var_clean(tl_seglvl1(:,:,:))
+   DEALLOCATE( tl_seglvl1 )
+
+   ! write file for each segment of each boundary
+   DO jl=1,ip_ncard
+      IF( tl_bdy(jl)%l_use )THEN
 
          SELECT CASE(TRIM(tl_bdy(jk)%c_card))
